
import snap7
from snap7.snap7exceptions import Snap7Exception
from snap7.snap7types import S7AreaDB, S7WLByte, S7DataItem
from snap7 import util

ip = '10.100.8.12'
tcpport = 102
rack = 0
slot = 1


script = SCRIPT ( ''' 
<!--  
function doStuff() 
{
    var myElement = document.getElementById(\"stuff\");
    if(myElement.innerText.length > 0)
    {
       window.location.reload();
    }
}
//-->
''' ,  TYPE= "text/javascript")

head = HEAD(TITLE("PLC HMI"))
onload = 'self.setInterval( \'doStuff()\', 1000)'
body = H1("PLC HMI")

def index():
        plcvalue =get_plc() 
        form = FORM(action="write")
        form <= INPUT(name="IB", value=plcvalue)
        form <= INPUT(Type="submit",value="Ok")
        return HTML( head+BODY(body + form))
 
def write(IB):
        set_plc ( int(IB) )
        plcvalue =get_plc() 
        form = FORM(action="refresh")
        form <= INPUT(Type="submit",value="Refresh")
        div = ( '<div style="width:500px;height:100px;border:1px solid #000;background-color:#' + hex(plcvalue+plcvalue*256) [2:]+ ';">Color changes ... </div>')
        return HTML( head +  BODY (body + div + str( plcvalue) + form  ))

def refresh():
        plcvalue =get_plc() 
        div = ( '<div style="width:500px;height:100px;border:1px solid #000;background-color:#' + hex(plcvalue+plcvalue*256 )[2:]+ ';">Color changes ... </div>')
        div1 = DIV ( str( plcvalue) )
        return HTML( script +  head +  BODY (body + div + div1 ,   id="stuff",  onload = onload ))


def get_plc():
        
    client = snap7.client.Client()
    client.connect(ip, rack, slot, tcpport)
    
    start = 0
    size = 1
    readdata = client.ab_read(start=start, size=size)

    client.disconnect()
    client.destroy()
    
    return readdata [0]

def set_plc( value ):
        
    client = snap7.client.Client()
    client.connect(ip, rack, slot, tcpport)
    
    start = 0
    size = 1
    data = bytearray(size)
    data[0] = value
    client.ab_write(start=start, data=data)

    client.disconnect()
    client.destroy()
    
    return 0
